%define subrel 0.1
%define epoch_arts 30000001

Name: phonon
Summary: KDE4 Multimedia Framework 
Version: 4.4.1
Release: %mkrel 6
Epoch: 2
Url: http://phonon.kde.org/
License: LGPLv2+
Group: Graphical desktop/KDE
BuildRoot: %{_tmppath}/%{name}-%{version}-build
# We're using git: http://gitorious.org/phonon
Source0: ftp://ftp.kde.org/pub/kde/stable/phonon/%version/%name-%version.tar.bz2
Source1: %{name}-gstreamer.svg
Patch1:  phonon-4.3.50-phonon-allow-stop-empty-source.patch
Patch2:  phonon-4.3.50-gstreamer-fix-seekable-query-failed.patch
# (cg) NB This version hack is only needed for 2010.0... added here too for ease of backporting
Patch4:  phonon-4.3.80-ignore-pulse-version.patch
Patch5:  phonon-4.4.1-use-decodebin.patch
Patch0100: 0100-xine-Initialise-volume-to-1.patch
Patch0101: 0101-pulse-Fix-the-reading-of-stream-information-on-start.patch
Patch0102: 0102-pulse-Hopefully-solve-erronious-error-message-relati.patch
Patch0103: 0103-pulse-Some-signal-emission-protection-and-some-debug.patch
Patch0104: 0104-gstreamer-Rejig-the-PulseAudio-detection-and-handlin.patch
Patch0105: 0105-gstreamer-Move-some-code-inside-pointer-protection.patch
Patch0106: 0106-pulse-Protect-the-PulseSupport-object-creation-by-a-.patch

# (cg) Phonon 4.4.1 needs Qt 4.6+
BuildRequires:  qt4-devel >= 4:4.6
BuildRequires:  kde4-macros
BuildRequires:  automoc
BuildRequires:  glib2-devel
BuildRequires:  libxml2-devel
BuildRequires:  imagemagick
BuildRequires:  pulseaudio-devel

%description
Phonon is the KDE4 Multimedia Framework

#--------------------------------------------------------------------

%define phononexperimental_major 4
%define libphononexperimental %mklibname phononexperimental %phononexperimental_major

%package -n %libphononexperimental
Summary: Phonon library
Group: System/Libraries
Conflicts: %{_lib}kdecore5 >= 30000000:3.80.3
Obsoletes: %{_lib}phononexperimental5 < 3.93.0-0.714006.1


%description -n %libphononexperimental
Phonon library.

%post -n %libphononexperimental -p /sbin/ldconfig
%postun -n %libphononexperimental -p /sbin/ldconfig

%files -n %libphononexperimental
%defattr(-,root,root)
%_kde_libdir/libphononexperimental.so.%{phononexperimental_major}*

#--------------------------------------------------------------------

%define phonon_major 4
%define libphonon %mklibname phonon %phonon_major

%package -n %libphonon
Summary: Phonon library
Group: System/Libraries
Conflicts: %{_lib}kdecore5 >= 30000000:3.80.3
Obsoletes: %{_lib}phonon5 < 3.93.0-0.714006.1

%description -n %libphonon
Phonon library.

%post -n %libphonon -p /sbin/ldconfig
%postun -n %libphonon -p /sbin/ldconfig

%files -n %libphonon
%defattr(-,root,root)
%_kde_libdir/libphonon.so.%{phonon_major}*

#-----------------------------------------------------------------------------

%package -n phonon-gstreamer
Summary: GStreamer backend to Phonon
Group: Sound
BuildRequires: libgstreamer-devel
BuildRequires: libgstreamer-plugins-base-devel
Requires: gstreamer0.10-plugins-good
Requires: gstreamer0.10-plugins-base
Suggests: gstreamer0.10-ffmpeg
Suggests: gstreamer0.10-soup
Suggests: gstreamer0.10-pulse
%if %mdkversion >= 201000
Obsoletes:      arts < %epoch_arts:1.5.10-9
Obsoletes:      arts3 < %epoch_arts:1.5.10-9
%endif

Provides: phonon-backend

%description -n phonon-gstreamer
GStreamer backend to Phonon.

%files -n phonon-gstreamer
%defattr(-,root,root)
%dir %_kde_libdir/kde4/plugins/phonon_backend
%_kde_libdir/kde4/plugins/phonon_backend/phonon_gstreamer.so
%_kde_datadir/kde4/services/phononbackends/gstreamer.desktop
%_datadir/icons/hicolor/*

#-----------------------------------------------------------------------------

%package -n phonon-xine
Summary: Xine backend to Phonon
Group: Sound
BuildRequires: libxine-devel
Obsoletes: kde4-phonon-xine < 1:3.93.0-0.714129.2
Requires: xine-plugins
Suggests: xine-pulse
Provides: phonon-backend

%description -n phonon-xine
Xine backend to Phonon.

%files -n phonon-xine
%defattr(-,root,root)
%dir %_kde_libdir/kde4/plugins/phonon_backend
%_kde_libdir/kde4/plugins/phonon_backend/phonon_xine.so
%_kde_datadir/kde4/services/phononbackends/xine.desktop
%_kde_iconsdir/*/*/*/phonon-xine.*

#--------------------------------------------------------------------

%package   devel
Group:     Development/KDE and Qt
Summary:   Header files and documentation for compiling KDE applications
Requires:  %libphononexperimental = %epoch:%version
Requires:  %libphonon = %epoch:%version
Conflicts: kdelibs4-devel < 4.0.80-5
Obsoletes: phonon-common
%if %mdkversion >= 201000
Obsoletes: arts-devel< %epoch_arts:1.5.10-9
Obsoletes: arts3-devel< %epoch_arts:1.5.10-9
%endif

%description devel
This package includes the header files you will need to compile applications
for KDE. Also included is the KDE API documentation in HTML format for easy
browsing.

%files devel
%defattr(-,root,root,-)
%{_kde_includedir}/phonon
%{_kde_includedir}/KDE
%{_kde_libdir}/libphonon.so
%{_kde_libdir}/libphononexperimental.so
%{_kde_libdir}/pkgconfig/phonon.pc
%{_kde_datadir}/dbus-1/interfaces/org.kde.Phonon.AudioOutput.xml

#--------------------------------------------------------------------

%prep
%setup -q  -n %name-%version
%apply_patches

%build
%cmake_kde4 \
	-DUSE_INSTALL_PLUGIN=TRUE

%make

%install
rm -fr %buildroot
%makeinstall_std -C build

# Make a nice icon
install -D -m 0644 %{_sourcedir}/%{name}-gstreamer.svg %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/%{name}-gstreamer.svg
for size in 16 22 32 48 64 128; do
  mkdir -p %{buildroot}%{_datadir}/icons/hicolor/${size}x${size}/apps
  convert -geometry ${size}x${size} %{_sourcedir}/%{name}-gstreamer.svg %{buildroot}%{_datadir}/icons/hicolor/${size}x${size}/apps/%{name}-gstreamer.png
done

%clean
rm -rf "%{buildroot}"



%changelog
* Tue Aug 17 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.4.1-6.0.1mdv2010.1
+ Revision: 571008
- Protect pulseaudio detection probe from multi-thread startup (maybe helps bko#232068)

* Wed May 12 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.4.1-6mdv2010.1
+ Revision: 544572
- Add some fixes related to mdv #59052

* Mon May 10 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.4.1-5mdv2010.1
+ Revision: 544364
- Use decodebin instead of decodebin2

* Fri May 07 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.4.1-4mdv2010.1
+ Revision: 543266
- Maybe fix a problem with incorrect error notification on startup with PA

* Tue Apr 27 2010 Christophe Fergeau <cfergeau@mandriva.com> 2:4.4.1-3mdv2010.1
+ Revision: 539591
- rebuild so that shared libraries are properly stripped again

* Sat Apr 24 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.4.1-2mdv2010.1
+ Revision: 538491
- Fix a couple problems with PA integration (bko#235193)

* Thu Apr 22 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.4.1-1mdv2010.1
+ Revision: 537855
- New version: 4.4.1

* Mon Apr 05 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-10.20100330.2mdv2010.1
+ Revision: 531604
- Fix UTF8 encoding in PA support. Mdv#57159

* Wed Mar 31 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-10.20100330.1mdv2010.1
+ Revision: 530081
- Update to latest git with PulseAudio per-application volume support.
- Drop upstream applied patch

* Wed Mar 17 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-10.20100317.1mdv2010.1
+ Revision: 524723
- Update to phonon git master.
- Drop merged patches
- Add PA connection rework (bko#228324)

* Thu Mar 11 2010 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.80-7mdv2010.1
+ Revision: 518012
- Remove requires in gstreamer0.10-plugins-ugly
- Add comment about patch2 merged upstream
- add infos for next update

* Wed Feb 03 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-6mdv2010.1
+ Revision: 499849
- Rework device moving on a system with PA underneath
- Remove version from the phonon-backend provide as it's not of any practical value

* Sun Jan 24 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-5mdv2010.1
+ Revision: 495602
- Fix an issue with pulsecleanup patch relating to startup configuration

* Sat Jan 23 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-4mdv2010.1
+ Revision: 495317
- Add a PA cleanup patch for wider debugging
- Use %%apply_patches macro (easier to manage)
- Update tarball to svn trunk
- Drop merged patches
- Fix xine output with PA under some error conditions

* Thu Jan 21 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-3mdv2010.1
+ Revision: 494635
- Fix another problem with gst backend relating to play->stop->play on a media object with PulseAudio (possibly alsa too)

* Thu Jan 14 2010 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.80-2mdv2010.1
+ Revision: 491078
- Remove unsed (and already applied upstream) patch
- Hopefully fix mdv#56807 (randomly disappearing sound under KDE+PA)

* Sun Dec 27 2009 Funda Wang <fwang@mandriva.org> 2:4.3.80-1mdv2010.1
+ Revision: 482675
- New version 4.3.80

* Mon Nov 23 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-21mdv2010.1
+ Revision: 469160
- Make sure pulseaudio stream moves are processed on reused streams.
- Remove old pulseaudio patch

* Sun Nov 22 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-20mdv2010.1
+ Revision: 469037
- Update to phonon trunk
- Remove four upstream-applied patches
- Remove version check on PulseAudio version (we know ours is OK)
- Renumber patches

* Sun Nov 15 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.50-19mdv2010.1
+ Revision: 466199
- Add requires on gstreamer-ugly, that fix the time bar in amarok

* Tue Oct 27 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-18mdv2010.0
+ Revision: 459458
- Some updates/fixes relating to pulseaudio support
-  Ensure the stream is moved when the device priorities change
-  Ensure the UI parts are correctly called to inform the user of whats happened when the device changes.
-  Add some extra debug

  + Nicolas Lécureuil <nlecureuil@mandriva.com>
    - Use decodebin2 instead of decodebin
      Use playbin2 instead of playbin
      BUG:51955

* Sat Oct 24 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.50-16mdv2010.0
+ Revision: 459181
- Add DVD support in the Gstreamer engine

* Sun Oct 18 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.50-15mdv2010.0
+ Revision: 458069
- Add xine-pulse as Suggests in phonon-xine

* Fri Oct 16 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.50-14mdv2010.0
+ Revision: 457859
- Add gstreamer0.10-pulse as suggests

* Thu Oct 15 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.50-13mdv2010.0
+ Revision: 457487
- Fix seekable streams

* Thu Oct 15 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.50-12mdv2010.0
+ Revision: 457485
- Add patches fixing the gstreamer engine

* Sun Oct 11 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-11mdv2010.0
+ Revision: 456615
- Fix xine output after latest changes.

* Sat Oct 10 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-10mdv2010.0
+ Revision: 456561
- Update PulseAudio support

* Sat Oct 03 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-9mdv2010.0
+ Revision: 453182
- Latest version of pulseaudio support
-  o Category priority lists now work.
-  o Notifications are sent when devices are added/removed.
- Drop upstream applied patches
- Update to trunk r1030942

* Fri Oct 02 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-8mdv2010.0
+ Revision: 452493
- Latest version of PulseAudio support patch (routing and priority now working for the 'No Category' case)

  + Nicolas Lécureuil <nlecureuil@mandriva.com>
    - Fix requires for phonon-gstreamer

  + Helio Chissini de Castro <helio@mandriva.com>
    - Update to phonon trunk latest source.
    - Remove current gst patch, as already included upstream by Colin

* Thu Sep 24 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-6mdv2010.0
+ Revision: 448193
- Add some fixes I pushed upstream for gstreamer device enumeration and backend reloading

* Wed Sep 23 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-5mdv2010.0
+ Revision: 447872
- Package eating monster munched -devel on i586... rebuild

* Wed Sep 23 2009 Colin Guthrie <cguthrie@mandriva.org> 2:4.3.50-4mdv2010.0
+ Revision: 447819
- Update pulseaudio patch slightly due to a copy paste error
- Revised pulseaudio detection patch that does not rely on Mandriva specific configs (that have been deprecated anyway)

* Mon Sep 21 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.50-3mdv2010.0
+ Revision: 446954
- Add patch from lmenut to support more that one CD/DVD driver

* Mon Sep 14 2009 Helio Chissini de Castro <helio@mandriva.com> 2:4.3.50-2mdv2010.0
+ Revision: 440619
- Byte your own tongue.. Add api support in trunk and forget to enable it in your own distro :-P

* Mon Sep 14 2009 Helio Chissini de Castro <helio@mandriva.com> 2:4.3.50-1mdv2010.0
+ Revision: 440615
- Use phonon trunk
- Removed backported trunk patches
- Added api and stream extract data patches in trunk

* Thu Sep 03 2009 Helio Chissini de Castro <helio@mandriva.com> 2:4.3.1-15mdv2010.0
+ Revision: 428957
- Removed implicit requires to pulse modules.

* Sat Aug 15 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.1-14mdv2010.0
+ Revision: 416458
- Fix typo
- Obsolete kde3 arts

* Thu Jun 04 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 2:4.3.1-13mdv2010.0
+ Revision: 382891
- Revert to phonon 4.3.1

* Sat May 30 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.3.50-0.975368.1mdv2010.0
+ Revision: 381233
- New snapshot
  Remove merged patches
  Rediff patches

* Thu May 28 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.3.1-12mdv2010.0
+ Revision: 380599
- Add patch from trunk to add equalizer effect in the xine engine

* Mon Apr 06 2009 Helio Chissini de Castro <helio@mandriva.com> 1:4.3.1-11mdv2009.1
+ Revision: 364421
- Remove extra suggests

* Fri Apr 03 2009 Helio Chissini de Castro <helio@mandriva.com> 1:4.3.1-10mdv2009.1
+ Revision: 363821
- phonon is not the place to obsolete arts

* Fri Mar 20 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.3.1-9mdv2009.1
+ Revision: 358263
- [Trunk] Add features in gstreamer engine
- Fix versionnate

* Wed Mar 18 2009 Helio Chissini de Castro <helio@mandriva.com> 1:4.3.1-7mdv2009.1
+ Revision: 357377
- Add initial support for gstreamer install plugins codec api, in a generic mode.
  This will allow default usage of Codeina or any helper script app as defined in the gstreamer compilation
- Removed old invalid patch

* Wed Mar 18 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.3.1-6mdv2009.1
+ Revision: 357305
- Fix obsoletes

* Tue Mar 17 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.3.1-5mdv2009.1
+ Revision: 356960
- Obsolete old arts

* Mon Mar 16 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.3.1-4mdv2009.1
+ Revision: 356217
- Remove subrel
  Bump release
- Add missing patch
- Add one revision per patch
- fix typo

* Fri Mar 06 2009 Colin Guthrie <cguthrie@mandriva.org> 1:4.3.1-3mdv2009.1
+ Revision: 349544
- Make strings translatable

* Sat Feb 28 2009 Helio Chissini de Castro <helio@mandriva.com> 1:4.3.1-2mdv2009.1
+ Revision: 346054
- Added backports patc for enconding fix.
- Added backport patch to stop/pause issue long seen in Amarok

* Fri Feb 27 2009 Helio Chissini de Castro <helio@mandriva.com> 1:4.3.1-1mdv2009.1
+ Revision: 345512
- Phonon 4.3.1 try#1 upstream release

* Mon Feb 23 2009 Colin Guthrie <cguthrie@mandriva.org> 1:4.3.0-2mdv2009.1
+ Revision: 344017
- Do not list any other devices when pulseaudio is enabled
- Pulseaudio is not an advanced output (patch seems to have been misconceived)

* Thu Jan 22 2009 Helio Chissini de Castro <helio@mandriva.com> 1:4.3.0-1mdv2009.1
+ Revision: 332566
- New upstream release tied to 4.2.0 upcoming release
- Fixed tarball from upstream

* Fri Jan 09 2009 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.2.96-1mdv2009.1
+ Revision: 327543
- New version 4.2.96

* Thu Dec 18 2008 Colin Guthrie <cguthrie@mandriva.org> 1:4.2.80-1.895450.2mdv2009.1
+ Revision: 315395
- Fix URL parsing (e.g. when [ or ] in the name). Fixes mdv#45950

* Wed Dec 10 2008 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.2.80-1.895450.1mdv2009.1
+ Revision: 312583
- Fix Release
- Update to new snapshot

* Mon Nov 24 2008 Helio Chissini de Castro <helio@mandriva.com> 1:4.2.80-1mdv2009.1
+ Revision: 306420
- Updated with fresh beta 1 official tarball

* Sun Oct 19 2008 Nicolas Lécureuil <nlecureuil@mandriva.com> 1:4.2.70-0.866326.2mdv2009.1
+ Revision: 295414
- Add epoch to ease upgrade
- New snapshot
- New snapshot

* Sun Oct 19 2008 Colin Guthrie <cguthrie@mandriva.org> 4.2.0-14mdv2009.1
+ Revision: 295176
- Slightly better patch that also handles .oga files
- Fix .ogg mime type handling

* Fri Oct 03 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2.0-13mdv2009.0
+ Revision: 291038
- added suggests for gstreamer plugins, allow uswers to have strea and mp3 as default

* Tue Sep 23 2008 Colin Guthrie <cguthrie@mandriva.org> 4.2.0-12mdv2009.0
+ Revision: 287159
- Fix broken path in my previous patch generation
- Revised patch for streaming data extraction.

* Sun Sep 21 2008 Colin Guthrie <cguthrie@mandriva.org> 4.2.0-11mdv2009.0
+ Revision: 286376
- Add a gstreamer icon
- Add a patch that requests metadata from streams via icydemux and
  fudge this info into ALBUM/ARTIST metadata.

* Sat Sep 20 2008 Colin Guthrie <cguthrie@mandriva.org> 4.2.0-10mdv2009.0
+ Revision: 286057
- Use the same icon as the xine icon for pulseaudio (yet to be supplied)
- Require gstreamer0.10-pulse in the gstreamer backend.

* Fri Sep 19 2008 Colin Guthrie <cguthrie@mandriva.org> 4.2.0-9mdv2009.0
+ Revision: 285790
- Update patch to use QSettings rather than KConfig (which was a silly idea in the first place)
- Add cosmetic patch for pulseaudio with gst backend (detect pulse via draksound settings)
- Remove profile.d env var setting scripts as this is now handled in pulseaudio patch

* Thu Sep 18 2008 Colin Guthrie <cguthrie@mandriva.org> 4.2.0-8mdv2009.0
+ Revision: 285742
- Set the glib application name for the benefit of gstreamer sink (app name is used by pulseaudio)

* Mon Sep 15 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2.0-7mdv2009.0
+ Revision: 285032
- auto audio sink

* Sun Sep 14 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2.0-6mdv2009.0
+ Revision: 284616
- Proper sink namex

* Sun Sep 14 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2.0-5mdv2009.0
+ Revision: 284611
- Pulse as a default audiosink in gstreamer

* Tue Sep 02 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2.0-4mdv2009.0
+ Revision: 279060
- update with latest branch with fixes

* Thu Aug 14 2008 Nicolas Lécureuil <nlecureuil@mandriva.com> 4.2.0-3mdv2009.0
+ Revision: 271687
- Add patch from trunk

* Wed Jul 30 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2.0-2mdv2009.0
+ Revision: 255126
- Add version to phonon-backend provides, to avoid apps requires phonon < 4.2

* Thu Jul 24 2008 Funda Wang <fwang@mandriva.org> 4.2.0-1mdv2009.0
+ Revision: 246522
- 4.2.0 final

  + Helio Chissini de Castro <helio@mandriva.com>
    - Cleaning my mess

* Tue Jun 10 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2-0.819157.1mdv2009.0
+ Revision: 217666
- Update phonon and fix devel install

* Tue Jun 03 2008 Helio Chissini de Castro <helio@mandriva.com> 4.2-0.815960.1mdv2009.0
+ Revision: 214437
- Enable gstreamer backend. Plugins now provides a virtual phonon-backend and main desktop will requires
  a phonon-backend instead of explicit one.
- Created phonon-common for dbus interfaces

* Thu May 29 2008 Nicolas Lécureuil <nlecureuil@mandriva.com> 4.2-0.814039.2mdv2009.0
+ Revision: 213136
- Comment a buildRequire
- Add BuildRequires
  Add TODO
- import phonon


